 /* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     David Robison
 * Student ID: 9823525
 * Section:    AH
 *	
 * 
 */

/*time.h is for seeding the random number generator.  stdio is for loading 
and saving files.*/
#include "gp142.h"
#include <math.h>
#include <time.h>
#include <stdio.h>

#define TRUE    		1
#define FALSE   		0

/*Statuses for various events in the program*/
#define STATUS_FONT_SIZE 12
#define STATUS_COLOR_PALLETE 3
#define STATUS_NONE 7
#define STATUS_SIZE_PALLETE 12

//Shape statuses
#define STATUS_ADD_SHAPE 1
#define STATUS_NO_SHAPE_SELECTED 4
#define STATUS_MAX_SHAPES 5
#define STATUS_SELECT_SHAPE 6
#define STATUS_SHAPE_SELECTED 8
#define STATUS_SHAPE_ANIMATION 9
#define STATUS_SHAPE_FLASH 10
#define STATUS_SHAPE_PALLETE 11

//Message statuses
#define STATUS_ADD_MESSAGE 13
#define STATUS_MESSAGE_SELECTED 14
#define STATUS_MESSAGE_SCROLL 15
#define STATUS_NO_MESSAGE_SELECTED 16
#define STATUS_MESSAGE_PALLETE 17
#define STATUS_MAX_MESSAGES 18
#define STATUS_SELECT_MESSAGE 19
#define STATUS_SPEED_PALLETE 21

//Border statuses
#define STATUS_NO_BORDER_SELECTED 20
#define STATUS_BORDER 22
#define STATUS_BORDER_PALLETE 23

//Background statuses

//File statuses
#define STATUS_FILE 24

/*Button sizes and colors*/
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	 110
#define BUTTON_THICKNESS 5
#define BUTTON_COLOR_SHADOW       BLACK
#define BUTTON_COLOR_HIGHLIGHT    WHITE
#define BUTTON_COLOR_MAIN         LT_GRAY
#define BUTTON_TEXT               BLACK
#define BUTTON_UNSELECTED_TEXT    WHITE
#define BUTTON_FONT_SIZE          12

/*Button constants*/
//First #define is always number of buttons

//Top buttons
#define TOP_BUTTONS 5
#define TOP_BACKGROUND 0
#define TOP_BORDER 1
#define TOP_SHAPE 2
#define TOP_MESSAGE 3
#define TOP_FILE 4

//Background buttons
#define BACKGROUND_BUTTONS 1
#define BACKGROUND_COLOR 0

//Border buttons
#define BORDER_BUTTONS 4
#define BORDER 0
#define BORDER_COLOR1 2
#define BORDER_COLOR2 3
#define BORDER_SIZE 1

//Shape buttons
#define SHAPE_BUTTONS 9
#define SHAPE_ADD 0
#define SHAPE_SELECT 1
#define SHAPE_SHAPE 2
#define SHAPE_COLOR1 3
#define SHAPE_COLOR2 4
#define SHAPE_SIZE 5
#define SHAPE_ANIMATE 6
#define SHAPE_FLASH 7
#define SHAPE_REMOVE 8

//Message buttons
#define MESSAGE_BUTTONS 8
#define MESSAGE_ADD 0
#define MESSAGE_SELECT 1
#define MESSAGE_MESSAGE 2
#define MESSAGE_COLOR 3
#define MESSAGE_SIZE 4
#define MESSAGE_SPEED 5
#define MESSAGE_SCROLL 6
#define MESSAGE_REMOVE 7

//File buttons
#define FILE_BUTTONS 6
#define FILE_SAVE1 0
#define FILE_SAVE2 1
#define FILE_SAVE3 2
#define FILE_LOAD1 3
#define FILE_LOAD2 4
#define FILE_LOAD3 5

//Button switches
#define BUTTON_RETURN_LL 0
#define BUTTON_RETURN_TR 1
#define BUTTON_NORMAL 0
#define BUTTON_SELECTED 1
#define BUTTON_UNSELECTED 2

//Card position
#define PAGE_LLX (-GP142_XMAX + BUTTON_WIDTH + 60)
#define PAGE_LLY (-GP142_YMAX + 80)
#define PAGE_WIDTH 400
#define PAGE_HEIGHT 360

//Fill and Nofill #defines for passing to GP142 functions
#define FILL 0
#define NOFILL 1

//Shapes supported
#define SHAPE_NONE -1
#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_SWIRL 2
#define SHAPE_FACE 3
//Shape sizes
#define SHAPE_SIZE_PALLETE 10
#define SHAPE_SIZE_SMALL 0
#define SHAPE_SIZE_MEDIUM 1
#define SHAPE_SIZE_LARGE 2
#define SHAPE_SIZE_HUGE 3 
//Number of shapes
#define NUM_SHAPES 10

//Message stuff
#define MESSAGE_NONE -1
//Message sizes
#define MESSAGE_SIZE_SMALL 0
#define MESSAGE_SIZE_MEDIUM 1
#define MESSAGE_SIZE_LARGE 2
#define MESSAGE_SIZE_HUGE 3 
//Number of messages
#define NUM_MESSAGES 10

//Possible places for mouse clicks
#define CLICK_TOP_BUTTON 1  
#define CLICK_CARD 2        
#define CLICK_OUTSIDE 3	    
#define CLICK_SIDE_BUTTON 4 
#define CLICK_COLOR_PALLETE 5 
#define CLICK_SHAPE_PALLETE 6 
#define CLICK_SIZE_PALLETE 7 
#define CLICK_SPEED_PALLETE 8
#define CLICK_MESSAGE_PALLETE 9
#define CLICK_BORDER_PALLETE 10


/*******************  FUNCTION PROTOTYPES **************************/

// Drawing functions 

//Drawing static stuff--buttons, palletes, cards
void DrawBlankScreen (void);
void DrawTopButtons (int current_top_button);
void DrawSideButtons (int current_top_button, int current_side_button);
void DrawCard (int background_color);
void DrawButton (int x1, int y1, char label[], 
                  int *x_ret, int *y_ret, 
                  int return_switch, int status);
void DrawShapePallete (int shape);
void DrawColorPallete (int color_num);
void DrawStatus (int status, int current_top_button);
void DrawSizePallete (int size);
void DrawMessagePallete (int message);
void DrawSpeedPallete (int speed);
void DrawBorderPallete (int border[]);
void DrawEdges ();
//Borders
void DrawBorder (int border, int color1, int color2, int size);
void DrawBorderShape (int x, int y, int color1, int color2, 
                      int size_x, int size_y, int shape);
//Drawing shapes
void DrawShapes (int shape [], int shape_x [], int shape_y [], 
                 int shape_color1 [], int shape_color2 [], 
                 int shape_size [], int shape_animate [], 
                 int shape_flash []);
void DrawHeart (int shape_x[], int shape_y[], int shape_color1[], 
                int shape_color2[], int shape_size[], int shape_animate[], 
                int shape_flash[], int shape_num);
void DrawStar (int shape_x[], int shape_y[], int shape_color1[], 
               int shape_color2[], int shape_size[], int shape_animate[], 
               int shape_flash[], int shape_num);
void DrawSwirl (int shape_x[], int shape_y[], int shape_color1[], 
                int shape_color2[], int shape_size[], int shape_animate[], 
                int shape_flash[], int shape_num);
void DrawFace (int shape_x[], int shape_y[], int shape_color1[], 
                int shape_color2[], int shape_size[], int shape_animate[], 
                int shape_flash[], int shape_num);
//Messages
void DrawMessages (int message [], int message_x [], int message_y [], 
                   int message_color [], int message_size [], 
                   int message_speed [], int message_scroll []); 

//Mouse click handling functions
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
  int *status, int *current_top_button, int *current_side_button,
  int *shape_current, int shape [], int shape_x[], int shape_y[],
  int shape_color1 [], int shape_color2 [], int shape_size [], 
  int shape_animate [], int shape_flash [],
  int *message_current, int message [], int message_x[], int message_y[],
  int message_color [], int message_size [], int message_scroll [], int message_speed[],
  int border[], int border_color1[], int border_color2[], int border_size[]);
int  ClassifyMouseClick(int mouse_x, int mouse_y, 
                        int current_top_button, int *status);
void HandleTopButton(int x, int y, int *current_top_button, 
                     int *current_side_button, int *shape_current, 
                     int *message_current, int *status);
void HandleSideButton(int x, int y, int current_top_button, 
  int *current_side_button, int *shape_current, int shape[], 
  int shape_animate[], int shape_flash[], int shape_x[], int shape_y[], 
  int shape_color1[], int shape_color2[], int shape_size[], 
  int *message_current, int message[], int message_scroll[], 
  int message_x [], int message_y[], int message_color[], 
  int message_size[], int message_speed[], int border[], 
  int border_color1[], int border_color2[], int border_size[], 
  int *status, int *background_color);
void HandleColorPallete (int mouse_x, int mouse_y, 
  int current_top_button, int current_side_button, int shape_current, 
  int shape_color1[], int shape_color2[], int message_current, 
  int message_color[], int border[], int border_color1 [], 
  int border_color2[], int *background_color);
void HandleCardClick (int mouse_x, int mouse_y, int current_top_button, 
  int *current_side_button, int *status, int *shape_current, 
  int shape[], int shape_x[], int shape_y[], int *message_current, 
  int message[], int message_x[], int message_y[]);
void HandleShapePallete (int mouse_x, int mouse_y, int shape_current, int shape[]);
void HandleSizePallete (int mouse_x, int mouse_y, int current, int size[]);
void HandleSpeedPallete (int mouse_x, int mouse_y, int current, int speed[]);
void HandleMessagePallete (int mouse_x, int mouse_y, int current, int message[]);
void HandleBorderPallete (int mouse_x, int mouse_y, int border[]);

/*Utility functions*/
int find_open_slot (int array[], int length);
int check_xy (int x[], int y[], int x_check, int y_check, int length);
void pause();
void draw_tag (mouse_x, mouse_y);


/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */	

  /*variables and their default values*/
	int background_color = YELLOW;
	int status;
	
	int current_top_button = 0;  //Keep track of which top button is selected	                                   
  int current_side_button = 0; //And which side buttons is selected

  /*Shape variables */
  int shape_current = -1; //Currently selected shape, -1 if none
  int shape [NUM_SHAPES]         = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1}; //Shape
  int shape_x [NUM_SHAPES]       = {0,0,0,0,0,0,0,0,0,0}; //Position
  int shape_y [NUM_SHAPES]       = {0,0,0,0,0,0,0,0,0,0};
  int shape_color1 [NUM_SHAPES]  = {0,0,0,0,0,0,0,0,0,0}; //Colors
  int shape_color2 [NUM_SHAPES]  = {1,1,1,1,1,1,1,1,1,1};
  int shape_size [NUM_SHAPES]    = {1,1,1,1,1,1,1,1,1,1}; //Size
  int shape_animate [NUM_SHAPES] = {0,0,0,0,0,0,0,0,0,0}; //Animation counter, 0 if none
  int shape_flash [NUM_SHAPES]   = {0,0,0,0,0,0,0,0,0,0}; //Flash counter, 0 if none

  /*message variables */
  int message_current = -1; //Currently selected message, -1 if none
  int message [NUM_MESSAGES]         = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1}; //message
  int message_x [NUM_MESSAGES]       = {0,0,0,0,0,0,0,0,0,0}; //Position
  int message_y [NUM_MESSAGES]       = {0,0,0,0,0,0,0,0,0,0};
  int message_color [NUM_MESSAGES]   = {0,0,0,0,0,0,0,0,0,0}; //Colors  
  int message_size [NUM_MESSAGES]    = {1,1,1,1,1,1,1,1,1,1}; //Size
  int message_speed [NUM_MESSAGES]   = {2,2,2,2,2,2,2,2,2,2};
  int message_scroll [NUM_MESSAGES]  = {0,0,0,0,0,0,0,0,0,0}; //Scroll counter

  /*border variables*/
  int border [1] = {-1};  //Shape or border type
  int border_color1 [1] = {0}; //Colors
  int border_color2 [1] = {1};
  int border_size [1] = {1};//Size

	int event; /*the most recent GP142 event*/

  time_t t; /*needed only when initializing a random number generator*/	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator.*/	

	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color);
		DrawShapes (shape, shape_x, shape_y, shape_color1, shape_color2, 
                shape_size, shape_animate, shape_flash);
   	DrawMessages (message, message_x, message_y, message_color, 
                  message_size, message_speed, message_scroll);
    DrawEdges ();
    DrawStatus (status, current_top_button);
    DrawBorder (border[0], border_color1[0], border_color2[0], border_size[0]);
    DrawTopButtons(current_top_button);	  /* Show the top buttons...*/ 
    DrawSideButtons(current_top_button, current_side_button); /*Show the side buttons*/


    /* Depending upon the top and side buttons pressed, this draws various palletes
    and sets the status properly to allow for selections from the pallete*/
    if (current_top_button == TOP_SHAPE) {
      //Handle shape buttons
      switch (current_side_button) {
        case SHAPE_COLOR1:
    	    DrawColorPallete (shape_color1 [shape_current]);
          status = STATUS_COLOR_PALLETE;
          break;
        case SHAPE_COLOR2: 
          DrawColorPallete (shape_color2 [shape_current]);
          status = STATUS_COLOR_PALLETE;
          break;
        case SHAPE_SHAPE: 
          DrawShapePallete (shape [shape_current]);
          status = STATUS_SHAPE_PALLETE;
          break;
        case SHAPE_SIZE: 
          DrawSizePallete (shape_size [shape_current]);
          status = STATUS_SIZE_PALLETE;
          break;
      }
    } else if (current_top_button == TOP_BACKGROUND) {
      //Handle background buttons
      if (current_side_button == BACKGROUND_COLOR) {
        DrawColorPallete (background_color);
        status = STATUS_COLOR_PALLETE;
      }
    } else if (current_top_button == TOP_MESSAGE) {
      //Handle message buttons
      switch (current_side_button) {
        case MESSAGE_COLOR:
    	    DrawColorPallete (message_color [message_current]);
          status = STATUS_COLOR_PALLETE;
          break;
        case MESSAGE_MESSAGE:
     	    DrawMessagePallete (message [message_current]);
          status = STATUS_MESSAGE_PALLETE;
         break;
        case MESSAGE_SIZE:
          DrawSizePallete (message_size [message_current]);
          status = STATUS_SIZE_PALLETE;
          break;
        case MESSAGE_SPEED:
     	    DrawSpeedPallete (message_speed [message_current]);
          status = STATUS_SPEED_PALLETE;
          break;
      }
    } else if (current_top_button == TOP_BORDER) {
      //Border Buttons
      switch (current_side_button) {
        case BORDER:
          DrawBorderPallete (border);
          status = STATUS_BORDER_PALLETE;
          break;
        case BORDER_SIZE:
          DrawSizePallete (border_size[0]);
          status = STATUS_SIZE_PALLETE;
          break;
        case BORDER_COLOR1:
    	    DrawColorPallete (border_color1[0]);
          status = STATUS_COLOR_PALLETE;
          break;
        case BORDER_COLOR2:
    	    DrawColorPallete (border_color2[0]);
          status = STATUS_COLOR_PALLETE;
          break;
      }
    }


		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			/*not needed for this program. Use this if user will need to 
			  hit a key. Note that scanf CANNOT be used with GP142.  If you 
			  use this, the key character value is in variable "key_hit"*/
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, &status, 					             
                       &current_top_button, &current_side_button,
                       &shape_current, shape, shape_x, shape_y,
                       shape_color1, shape_color2, shape_size, shape_animate, 
                       shape_flash,
                       &message_current, message, message_x, message_y, 
                       message_color, message_size, message_scroll, message_speed,
                       border, border_color1, border_color2, border_size
      );			
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed
      program does "nothing," just takes a step in all animations*/				
			break;

		default:			
			break;
			
		}  /*end switch */
		
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a light gray rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (LT_GRAY,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */

//Draw the card only.  Pass the color for the card.
void DrawCard (int background_color)
{
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX + PAGE_WIDTH, PAGE_LLY + PAGE_HEIGHT,
		FILL);		
} /*end DrawPage */

/*Draws the edges of the card.  This masks things that extend beyond the borders, and makes
the scrolling text possible*/
void DrawEdges () {
  /*Each rectangle is on one side of the card.*/  
	GP142_rectangleXY (LT_GRAY,
		-GP142_XMAX, -GP142_YMAX,
		PAGE_LLX, GP142_YMAX,
		FILL);	  
	GP142_rectangleXY (LT_GRAY,
		PAGE_LLX, GP142_YMAX,
		GP142_XMAX, PAGE_LLY + PAGE_HEIGHT,
		FILL);	
	GP142_rectangleXY (LT_GRAY,
		GP142_XMAX, PAGE_LLY + PAGE_HEIGHT,
		PAGE_LLX + PAGE_WIDTH, -GP142_YMAX,
		FILL);	
	GP142_rectangleXY (LT_GRAY,
		PAGE_LLX + PAGE_WIDTH, -GP142_YMAX,
		PAGE_LLX, PAGE_LLY,
		FILL);	
}

/*Draw the shapes on the card.  Pass ALL of the shape arrays and then it will call the 
appropriate functions to draw them.*/
void DrawShapes (int shape [], int shape_x [], int shape_y [], int shape_color1 [], 
                 int shape_color2 [], int shape_size [], int shape_animate [], 
                 int shape_flash []) {
  int count;
  for (count = 0; count < NUM_SHAPES; count++) {    
    //Loop through the shape array and draw each shape
		switch (shape[count]) {
		case SHAPE_HEART:
			DrawHeart (shape_x, shape_y, shape_color1, shape_color2,
                 shape_size, shape_animate, shape_flash, count);
			break;
		case SHAPE_STAR:
			DrawStar (shape_x, shape_y, shape_color1, shape_color2,
                shape_size, shape_animate, shape_flash, count);
			break;
  	case SHAPE_SWIRL:
			DrawSwirl (shape_x, shape_y, shape_color1, shape_color2,
                 shape_size, shape_animate, shape_flash, count);
    	break;
		case SHAPE_FACE:
			DrawFace (shape_x, shape_y, shape_color1, shape_color2,
                 shape_size, shape_animate, shape_flash, count);
    	break;
		} /*end switch*/
  }

}

/*Draw the messages on the card.  Unlike the DrawShapes, this doesn't call different functions, it
just changes the message based upon the value stored in message[].  Again, pass ALL message
arrays*/
void DrawMessages (int message [], int message_x [], int message_y [], 
  int message_color [],  int message_size [], int message_speed[], 
  int message_scroll []) { 
  /*Message 7 is the trick message, and is therefore just ""*/
  char message_list [7][25] = {
    "I love you", 
    "Will you be mine?", 
    "Kiss me",
    "For my sweetie",
    "From your honey",
    "GO DAWGS!",
    "",
  }, mess [25], sub_mess [25];
  int count, mess_x, mess_y, mess_color, mess_size, mess_scroll, mess_num, 
      size, mess_speed;

  for (count = 0; count < NUM_MESSAGES; count++) {    
    //Loop through the message array and draw each message
    mess_num    = message [count];
    if (mess_num != -1) {
      strcpy (mess, message_list [mess_num]);
      mess_x      = message_x [count];
      mess_y      = message_y [count];
      mess_color  = message_color [count];
      mess_size   = message_size [count];
      mess_speed  = message_speed [count];
      mess_scroll = message_scroll [count];

      //Handle font size  
      switch (mess_size) {
        case MESSAGE_SIZE_SMALL: size = 12; break;
        case MESSAGE_SIZE_LARGE: size = 36; break;
        case MESSAGE_SIZE_HUGE:  size = 60; break;
        case MESSAGE_SIZE_MEDIUM:
        default:
          size = 24;
          break;
      }
      
      //Handle scrolling speed
      switch (mess_speed) {
        case 0: mess_speed = 1; break;
        case 1: mess_speed = 2; break;
        case 2: mess_speed = 4; break;
        case 3: mess_speed = 8; break;
        case 4:
        default:
          mess_speed = 16;
          break;
      }

      //If it is scrolling, move it to the right a little bit
      if (mess_scroll == 1) {
        if (mess_x >= (PAGE_LLX + PAGE_WIDTH))
          message_x [count] = PAGE_LLX + mess_speed;
        else
          message_x [count] = mess_x + mess_speed;    
      }

      if (mess_num == 6) {
        /*if it's the subliminal message, check to see if it's time, and
        if it is, then flash a message*/
        mess_scroll = mess_scroll + mess_speed;
        if (mess_scroll > 24) mess_scroll = 2;
        message_scroll[count] = mess_scroll;
        if (mess_scroll == 2) {
          mess_x = (rand() % PAGE_WIDTH) + PAGE_LLX;
          mess_y = (rand() % PAGE_HEIGHT) + PAGE_LLY;
          //I like tight code
          switch (rand() % 3) {
            case 0:strcpy (sub_mess, "4.0");break;
            case 1:strcpy (sub_mess, "$$$");break;
            case 2:strcpy (sub_mess, "SEX");break;
          }
          GP142_printfXY (mess_color, mess_x, mess_y, size, sub_mess);
          GP142_printfXY (mess_color, mess_x - PAGE_WIDTH, mess_y, size, sub_mess);
        }
      } else {
        GP142_printfXY (mess_color, mess_x, mess_y, size, mess);
        GP142_printfXY (mess_color, mess_x - PAGE_WIDTH, mess_y, size, mess);    
      }
    }
  } 
}



/*Draw a heart.  Pass all the shape arrays and the shape number that is the actual heart.
It will flash and pulsate depending upon various variables set by user.
The following #define's are based upon some geometric constructions I did to
get the heart to draw correctly.  Trust that they're right.  
They took me a while to figure out.*/
#define HEART_CIRCLE_OFFSET .416666
#define HEART_POINT 1.03906
#define HEART_LINE_DOWN 1.34266
#define HEART_LINE_OVER .66667
void DrawHeart (int shape_x[], int shape_y[], int shape_color1[], 
               int shape_color2[], int shape_size[], int shape_animate[], 
               int shape_flash[], int shape_num) {

  int x = shape_x[shape_num], y = shape_y[shape_num], 
    color1 = shape_color1[shape_num], color2 = shape_color2[shape_num], 
    size = shape_size[shape_num], animate = shape_animate[shape_num], 
    flash = shape_flash[shape_num];
  int temp, h, h_c_offset, h_o1, h_o2, h_end, anim_var, max_size;

	//Deal with flashing
  if (flash > 8) 
    shape_flash[shape_num] = 1; //reset flash back to 1
  else if (flash != 0)
    shape_flash[shape_num] = flash + 1; //move flash forward 1

  if (flash > 6) {//If flashing and in second half, flip colors
    temp   = color1;
    color1 = color2;
    color2 = temp;
  }

  //Select size, these should be even to get the pixels to work right
  //Also sets an animation variable that changes with size (larger hearts have a larger pulsation)
  switch (size) {
    case SHAPE_SIZE_PALLETE:
      h = 20;
      break;
    case SHAPE_SIZE_SMALL:
      h = 22;
      anim_var = 1;
      max_size = 4;
      break;
    case SHAPE_SIZE_LARGE:
      h = 80;
      anim_var = 4;
      max_size = 20;
      break;
    case SHAPE_SIZE_HUGE:
      h = 175;
      anim_var = 8;
      max_size = 40;
      break;
    case SHAPE_SIZE_MEDIUM:
    default:
      h = 34;
      anim_var = 2;
      max_size = 10;
     break;
  }

  //Do animation, if necessary
  if (animate != 0) {
    h = h + max_size - animate;
    animate = animate + anim_var;
    if (animate > max_size)
      animate = 1;
    shape_animate [shape_num] = animate;
  } 

  //Find the points to draw the heart
  h_c_offset = (int)(h * HEART_CIRCLE_OFFSET);
  h_o1 = (int)((h / 2.0) * HEART_LINE_OVER);
  h_o2 = (int)((h / 2.0) / HEART_LINE_DOWN);
  h_end = (int)(h * HEART_POINT);
  
  //Draw the heart
	GP142_circleXY   (color1, x, y - (h / 2), (h / 4));
  GP142_circleXY   (color1, x - h_c_offset, y, (h / 2));
	GP142_circleXY   (color1, x + h_c_offset, y, (h / 2));
	GP142_triangleXY (color1, x - h_c_offset - h_o1, y - h_o2,
						                x + h_c_offset + h_o1-1, y - h_o2,
						                x, y - h_end, FILL);
}


/*Draw a star.  Pass the shape array's and the number that is a star.*/
#define STARPOINTS 2
#define PI 3.1416
#define DEG2RAD 0.01745 //Conversion for degrees to radians
void DrawStar (int shape_x[], int shape_y[], int shape_color1[], 
               int shape_color2[], int shape_size[], int shape_animate[], 
               int shape_flash[], int shape_num) {

  int x = shape_x[shape_num], y = shape_y[shape_num], 
    color1 = shape_color1[shape_num], color2 = shape_color2[shape_num], 
    size = shape_size[shape_num], animate = shape_animate[shape_num], 
    flash = shape_flash[shape_num];

  int sp, x1, y1, count, color, radius;
	double angle, angle_add, current_angle;
	
  //Deal with animation
  //If it is animated, the number of lines ascends and descends from 2 - 12
  //If not animated, it gets four lines
  if (animate != 0) {
    animate = animate + 1;
    if (animate > 12)animate = 1;
    shape_animate[shape_num] = animate;
    if (animate > 6)
      animate = 12 - animate;
    sp = STARPOINTS + animate;
    angle = animate * 15 * DEG2RAD;    
  } else {
    sp = STARPOINTS + 2;//Four lines
    angle = 0;
  }
  angle_add = PI / sp;//Same for both

  //Adjust size
  switch (size) {
    case SHAPE_SIZE_PALLETE: radius = 20; break;
    case SHAPE_SIZE_SMALL:   radius = 20; break;
    case SHAPE_SIZE_LARGE:   radius = 80; break;
    case SHAPE_SIZE_HUGE:    radius = 170; break;
    case SHAPE_SIZE_MEDIUM:
    default:
      radius = 40;
      break;
  }

  for (count = 0; count < sp; count++) {
    //For loop to draw the lines of the star
    current_angle = angle + angle_add * count;
		x1 = (int) (cos (current_angle) * radius);
		y1 = (int) (sin (current_angle) * radius);
    if (flash != 0) {
      //Deal with flashing here
      if (rand() % 4 == 0)
        color = color2;
      else
        color = color1;
      flash = flash + 1;
    } else {
      color = color1;
    }
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 2);
	}
}

/*Draw a face, pass all the shape arrays and the number that is a face.
Flash will cause the eyes to blink, animate moves the pupils and mouth*/
void DrawFace (int shape_x[], int shape_y[], int shape_color1[], 
                int shape_color2[], int shape_size[], int shape_animate[], 
                int shape_flash[], int shape_num) {
  
  int x = shape_x[shape_num], y = shape_y[shape_num], 
    color1 = shape_color1[shape_num], color2 = shape_color2[shape_num], 
    size = shape_size[shape_num], animate = shape_animate[shape_num], 
    flash = shape_flash[shape_num];
  int x_rand, y_rand, radius, eye_radius, eye_y, eye_x1, eye_x2, pupil_y, 
    pupil_x1, pupil_x2, mouth_y1, mouth_x1, mouth_x2, pupil_radius, mouth_y2;
  
  //Adjust size
  switch (size) {
    case SHAPE_SIZE_PALLETE: radius = 20;  break;
    case SHAPE_SIZE_SMALL:   radius = 20;  break;
    case SHAPE_SIZE_LARGE:   radius = 80;  break;
    case SHAPE_SIZE_HUGE:    radius = 170; break;
    case SHAPE_SIZE_MEDIUM:      
    default:
      radius = 40;
      break;
  }

  //Get various sizes and points for constructing the face
  eye_radius = (radius / 5);
  pupil_radius = eye_radius / 3;
  eye_y = y + eye_radius;
  pupil_y = eye_y;
  eye_x1 = x - (int)(1.5 * eye_radius);
  pupil_x1 = eye_x1;
  eye_x2 = x + (int)(1.5 * eye_radius);
  pupil_x2 = eye_x2;
  mouth_y1 = y - eye_radius;
  mouth_y2 = mouth_y1 - eye_radius;
  mouth_x1 = x - eye_radius * 2;
  mouth_x2 = x + eye_radius * 2;

  //Animation
  if (animate != 0) {
    animate = animate + 1;
    if (animate > 5) animate = 1;
    shape_animate[shape_num] = animate;
    x_rand = rand() % eye_radius - (eye_radius / 2);
    y_rand = rand() % eye_radius - (eye_radius / 2);
    //Pupils are moved together
    pupil_x1 = pupil_x1 + x_rand;
    pupil_x2 = pupil_x2 + x_rand;
    pupil_y = pupil_y + y_rand;
    //Mouth is opened/closed
    mouth_y2 = mouth_y1 - (int)(((rand() % 6)+1) * eye_radius * 0.25);
  }  

  //Draw the face
  GP142_circleXY (color1, x, y, radius);
  GP142_circleXY (WHITE, eye_x1, eye_y, eye_radius);
  GP142_circleXY (WHITE, eye_x2, eye_y, eye_radius);
  GP142_circleXY (BLACK, pupil_x1, pupil_y, pupil_radius);
  GP142_circleXY (BLACK, pupil_x2, pupil_y, pupil_radius);
  GP142_triangleXY (RED, mouth_x1, mouth_y1, 
                         x, mouth_y2, 
                         mouth_x2, mouth_y1, FILL);
  
  //Blink if it is flashing
  if (flash != 0) {
    flash = flash + 1;
    if (flash > 16) flash = 1;
    shape_flash[shape_num] = flash;
    switch (flash) {
      case 14:
      case 16:
        GP142_rectangleXY (color1, 
                           eye_x1 - eye_radius, eye_y + eye_radius, 
                           eye_x1 + eye_radius, eye_y,
                           FILL);
        GP142_rectangleXY (color1, 
                           eye_x2 - eye_radius, eye_y + eye_radius, 
                           eye_x2 + eye_radius, eye_y,
                           FILL);
        break;
      case 15:
        GP142_circleXY (color1, eye_x1, eye_y, eye_radius);
        GP142_circleXY (color1, eye_x2, eye_y, eye_radius);
        break;
    }    
  }
}

/*Draw a swirl.  Pass shapes and the number that is the swirl.*/
#define PI 3.1416
#define ANG_30 0.2618 //15 degrees
void DrawSwirl (int shape_x[], int shape_y[], int shape_color1[], 
                int shape_color2[], int shape_size[], int shape_animate[], 
                int shape_flash[], int shape_num) {
  int x = shape_x[shape_num], y = shape_y[shape_num], 
    color1 = shape_color1[shape_num], color2 = shape_color2[shape_num], 
    size = shape_size[shape_num], animate = shape_animate[shape_num], 
    flash = shape_flash[shape_num];

	double angle, length, length_divisor, length_add;
	int new_x, new_y, add_x, add_y, count, loop_count, color, 
      flash1, flash2, flash3, flash4, loops;

  /*Adjust size, based upon the number of loops in the swirl
    Length_divisor adjusts the width of the swirl, length_add adjusts the "tightness" of the spirals*/
  switch (size) {
    case SHAPE_SIZE_PALLETE:
      loops = 3;
      length_divisor = 5;
      length_add = .1;
      break;
    case SHAPE_SIZE_SMALL:
      loops = 3;
      length_divisor = 4;
      length_add = .075;  
      break;
    case SHAPE_SIZE_LARGE:
      loops = 5;
      length_divisor = 2;
      length_add = .2;  
      break;
    case SHAPE_SIZE_HUGE:
      loops = 6;
      length_divisor = 3;
      length_add = .3;  
      break;
    case SHAPE_SIZE_MEDIUM:
    default:
      loops = 3;
      length_divisor = 1.5;
      length_add = .15;  
      break;
  }
  loop_count = loops * 24; //Loops * 24 = number of 15 degree angles in that many loops

  //Animation--will turn if animated
  if (animate != 0) {
    angle = animate * -.3;
    shape_animate[shape_num] = animate + 1;
  } else {
    angle = 0.0;
  }

  //Flash
  if (flash != 0) {
    flash = flash + 2;
    if (flash > loop_count)
      flash = 1;
    shape_flash[shape_num] = flash;
    flash1 = flash;
    flash2 = flash + (int)(loop_count * 0.25);
    flash3 = flash + (int)(loop_count * 0.5);
    flash4 = flash + (int)(loop_count * 0.75);  
    if (flash1 > loop_count) flash1 = flash1 - loop_count;
    if (flash2 > loop_count) flash2 = flash2 - loop_count;
    if (flash3 > loop_count) flash3 = flash3 - loop_count;
    if (flash4 > loop_count) flash4 = flash4 - loop_count;
  }

	for (count = 0, length = 0.0; 
       count < loop_count; 
       count++, angle = angle + ANG_30, length = length + length_add) {
    //Draw the actual swirl here
		add_x = (int) (cos (angle) * length);
		add_y = (int) (sin (angle) * length);
    new_x = x + add_x;
    new_y = y + add_y;
    if (flash != 0)
      //Deal with the flashing
      if (count   == flash1 || count   == flash2 || count   == flash3 ||
          count+1 == flash1 || count+1 == flash2 || count+1 == flash3 ||
          count-1 == flash1 || count-1 == flash2 || count-1 == flash3)
        color = color2;
      else 
        color = color1;
    else
      color = color1;
    //Draw one of the lines of the swirl
		GP142_lineXY (color, x, y, new_x, new_y, 
                  (int) ((length / length_divisor) + 1) );
    //Increment x and y for next time around
    x = new_x;
    y = new_y;
	}
}

/*Decide where a mouse click occured, and react appropriately.  Pass most of the variables
that are defined so it can update the if necessary.*/
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
            int *status, 
            int *current_top_button, int *current_side_button,
            int *shape_current, int shape [], int shape_x[], int shape_y[],
            int shape_color1 [], int shape_color2 [], int shape_size [], 
            int shape_animate [], int shape_flash [],
            int *message_current, int message [], int message_x[], 
            int message_y[], 
            int message_color[], int message_size [], int message_scroll [], 
            int message_speed[],
            int border[], int border_color1[], int border_color2[], 
            int border_size[])
{

	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y, *current_top_button, status);
			
	if (mouse_click == CLICK_TOP_BUTTON) {				
    //Top button was clicked
    HandleTopButton(mouse_x, mouse_y, current_top_button, current_side_button, 
      shape_current, message_current, status);
  } else if (mouse_click == CLICK_SIDE_BUTTON) {
    //Side button was clicked
    HandleSideButton(mouse_x, mouse_y, *current_top_button, current_side_button, 
                     shape_current, shape, shape_animate, shape_flash,
                     shape_x, shape_y, shape_color1, shape_color2, shape_size,
                     message_current, message, message_scroll, message_x, 
                     message_y, message_color, message_size, message_speed,                      
                     border, border_color1, border_color2, border_size,
                     status, background_color);
	} else if (mouse_click == CLICK_CARD) {
    //Card was clicked
    HandleCardClick (mouse_x, mouse_y, *current_top_button, current_side_button, 
                     status, shape_current, shape, shape_x, shape_y,
                     message_current, message, message_x, message_y);
	} else if (mouse_click == CLICK_COLOR_PALLETE) {
    //Color pallete was selected  
    HandleColorPallete(mouse_x, mouse_y, *current_top_button, 
                  *current_side_button, *shape_current, shape_color1, 
                  shape_color2, *message_current, message_color,
                  border, border_color1, border_color2,
                  background_color);
  } else if (mouse_click == CLICK_SHAPE_PALLETE) {
    //Shape pallete was selected
    HandleShapePallete(mouse_x, mouse_y, *shape_current, shape);
  } else if (mouse_click == CLICK_SIZE_PALLETE) {
    if (*current_top_button == TOP_SHAPE) {
      //Size pallete was selected for a shape
      HandleSizePallete(mouse_x, mouse_y, *shape_current, shape_size);  
    } else if (*current_top_button == TOP_MESSAGE) {
      //Size pallete was selected for a message
      HandleSizePallete(mouse_x, mouse_y, *message_current, message_size);  
    } else if (*current_top_button == TOP_BORDER) {
      //Size pallete was selected for a border
      HandleSizePallete(mouse_x, mouse_y, 0, border_size);
    }
  } else if (mouse_click == CLICK_SPEED_PALLETE) {
    //Speed pallete was selected
    HandleSpeedPallete(mouse_x, mouse_y, *message_current, message_speed);    
  } else if (mouse_click == CLICK_MESSAGE_PALLETE) {
    //Message pallete was selected
    HandleMessagePallete(mouse_x, mouse_y, *message_current, message);
  } else if (mouse_click == CLICK_BORDER_PALLETE) {
    //Border pallete was selected
    HandleBorderPallete (mouse_x, mouse_y, border);
  }
	/* Ignore any other mouse clicks */
}

/*Routine to draw a pretty button.  Pass it the top left coordinate and it will draw you
a button.  Status controls the color of the button text.  Will return either the lower 
left or upper right corner, depending upon return_switch.*/
void DrawButton (int x1, int y1, char label[], 
                  int *x_ret, int *y_ret, 
                  int return_switch, int status) {  
  int x2, y2, inside_x1, inside_x2, inside_y1, inside_y2, label_x, 
      label_y, label_color,
  highlight_color, shadow_color;

  //Get button points  
  x2 = x1 + BUTTON_WIDTH;
  y2 = y1 - BUTTON_HEIGHT;
  inside_x1 = x1 + BUTTON_THICKNESS;
  inside_y1 = y1 - BUTTON_THICKNESS;
  inside_x2 = x2 - BUTTON_THICKNESS;
  inside_y2 = y2 + BUTTON_THICKNESS;
  label_x = inside_x1 + BUTTON_FONT_SIZE;
  label_y = ( (y1 + y2) / 2) - (BUTTON_FONT_SIZE / 2);

  //Set colors based upon button status (unselected was never actually used, oh well)
  switch (status) {
    case BUTTON_SELECTED :          
      label_color = BUTTON_TEXT;   
      highlight_color = BUTTON_COLOR_SHADOW;
      shadow_color = BUTTON_COLOR_HIGHLIGHT;
      label_x = label_x + 3;
      label_y = label_y - 1;
      break;
    case BUTTON_UNSELECTED :        
      label_color = BUTTON_UNSELECTED_TEXT; 
      shadow_color = BUTTON_COLOR_SHADOW;
      highlight_color = BUTTON_COLOR_HIGHLIGHT;
     break;
    case BUTTON_NORMAL : default :  
      label_color = BUTTON_TEXT;            
      shadow_color = BUTTON_COLOR_SHADOW;
      highlight_color = BUTTON_COLOR_HIGHLIGHT;
      break;
  }

  //Draw highlight
  GP142_rectangleXY (highlight_color, x1, y1, inside_x1, inside_y1, FILL);
  GP142_rectangleXY (highlight_color, x1, inside_y1, inside_x1, inside_y2, FILL);
  GP142_rectangleXY (highlight_color, inside_x1, y1, inside_x2, inside_y1, FILL);
  GP142_triangleXY (highlight_color, x1, inside_y2, 
                                     inside_x1, inside_y2, 
                                     x1, y2, FILL);
  GP142_triangleXY (highlight_color, inside_x2, y1, 
                                     x2, y1, 
                                     inside_x2, inside_y1, FILL);

  //Draw shadow
  GP142_rectangleXY (shadow_color, x2, y2, inside_x2, inside_y2, FILL);
  GP142_rectangleXY (shadow_color, x2, inside_y2, inside_x2, inside_y1, FILL);
  GP142_rectangleXY (shadow_color, inside_x2, y2, inside_x1, inside_y2, FILL);
  GP142_triangleXY (shadow_color, x2, inside_y1, 
                                  inside_x2, inside_y1, 
                                  x2, y1, FILL);
  GP142_triangleXY (shadow_color, inside_x1, y2, 
                                  x1, y2, 
                                  inside_x1, inside_y2, FILL);

  //Draw button
  GP142_rectangleXY (BUTTON_COLOR_MAIN, inside_x1, inside_y1, 
                                        inside_x2, inside_y2, FILL);
  GP142_lineXY (BUTTON_COLOR_MAIN, x1, y1, x1, y2, 1);
  GP142_lineXY (BUTTON_COLOR_MAIN, x1, y1, x2, y1, 1);
  GP142_lineXY (shadow_color, x2, y2, x1, y2, 1);
  GP142_lineXY (shadow_color, x2, y2, x2, y1, 1);

  //Label button
  GP142_printfXY (label_color, label_x, label_y, BUTTON_FONT_SIZE, label);

  //Return what the user wants--either lower left or top right corner
  //Makes drawing next button easy
  switch (return_switch) {
    case BUTTON_RETURN_LL : 
      *x_ret = x1;
      *y_ret = y2;
      break;
    case BUTTON_RETURN_TR :
      *x_ret = x2;
      *y_ret = y1;
      break;
  }

  return;
}

//Draw top buttons.  Pass the top button to be highlighted.*/
void DrawTopButtons(int current_top_button)
{
	char b_labels [TOP_BUTTONS][25] = {
    "Background",
    "Border",
    "Shape",
    "Message",
    "Files"
  };
  int count, x, y, button_status;

  x = -GP142_XMAX + 2;
  y = GP142_YMAX - 2;

	/* Draw buttons*/
	for(count = 0; count < TOP_BUTTONS; count++) {
    //If handles which button is selected
    if (count == current_top_button)
      button_status = BUTTON_SELECTED;
    else 
      button_status = BUTTON_NORMAL;

    DrawButton (x, y, b_labels [count], &x, &y, BUTTON_RETURN_TR, button_status);		
	}	
}

//Draw side buttons.  Pass the top button to be highlighted.*/
void DrawSideButtons (int current_top_button, int current_side_button) {
  int button_number, count, x, y, button_status;
  char b_labels [10][25];

  /*Switch based upon the top button selected, changing the labels.
  I got tired of using #defines.  Sorry*/
  switch (current_top_button) {
    case TOP_BACKGROUND:
      button_number = BACKGROUND_BUTTONS;
      strcpy (b_labels [0], "Color");
      break;
    case TOP_BORDER:
      button_number = BORDER_BUTTONS;
      strcpy (b_labels [0], "Shape");
      strcpy (b_labels [1], "Size");
      strcpy (b_labels [2], "Primary Color");
      strcpy (b_labels [3], "Secondary Color");
      break;
    case TOP_SHAPE:
      button_number = SHAPE_BUTTONS;
      strcpy (b_labels [SHAPE_ADD], "Add");
      strcpy (b_labels [SHAPE_SELECT], "Select");
      strcpy (b_labels [SHAPE_SHAPE], "Shape");
      strcpy (b_labels [SHAPE_COLOR1], "Shape Color");
      strcpy (b_labels [SHAPE_COLOR2], "Flash Color");
      strcpy (b_labels [SHAPE_SIZE], "Size");
      strcpy (b_labels [SHAPE_ANIMATE], "Animate");
      strcpy (b_labels [SHAPE_FLASH], "Flash");
      strcpy (b_labels [SHAPE_REMOVE], "Remove");
      break;
    case TOP_MESSAGE:
      button_number = MESSAGE_BUTTONS;
      strcpy (b_labels [0], "Add");
      strcpy (b_labels [1], "Select");      
      strcpy (b_labels [2], "Message");
      strcpy (b_labels [3], "Color");
      strcpy (b_labels [4], "Size");
      strcpy (b_labels [5], "Speed");
      strcpy (b_labels [6], "Scroll");
      strcpy (b_labels [7], "Remove");
      break;
    case TOP_FILE:
      button_number = FILE_BUTTONS;
      strcpy (b_labels [0], "Save 1");
      strcpy (b_labels [1], "Save 2");
      strcpy (b_labels [2], "Save 3");
      strcpy (b_labels [3], "Load 1");
      strcpy (b_labels [4], "Load 2");
      strcpy (b_labels [5], "Load 3");
      break;
  }

  //Find top left corner to start at
  x = -GP142_XMAX + 2;
  y = GP142_YMAX - 2 - (int)(BUTTON_HEIGHT * 1.5);

	/* Draw buttons*/
	for(count = 0; count < button_number; count++) {
    if (count == current_side_button)
      button_status = BUTTON_SELECTED;
    else 
      button_status = BUTTON_NORMAL;

    //X and Y are incremented in the DrawButton fuction
    DrawButton (x, y, b_labels [count], &x, &y, BUTTON_RETURN_LL, button_status);		
  }	
}

//Handles user selecting the top button--pass a bunch of variables for it to update
void HandleTopButton(int x, int y, int *current_top_button, 
  int *current_side_button, int *shape_current, int *message_current, 
  int *status) {

  int new_top_button;
	new_top_button = (GP142_XMAX + x) / BUTTON_WIDTH;
  if (new_top_button != *current_top_button) {
    //Reset side button if top button was changed
    *current_side_button = 0;
    //Update some other variables, too, depending on which button was newly selected
    if (new_top_button == TOP_SHAPE) {
      *shape_current = -1;    
      *status = STATUS_ADD_SHAPE;
    }
    if (new_top_button == TOP_MESSAGE) {
      *message_current = -1;
      *status = STATUS_ADD_MESSAGE;
    }
  }
  *current_top_button = new_top_button;  
  if (*current_top_button == TOP_FILE) {
    //File button is a little special
    *current_side_button = -1;
    *status = STATUS_FILE;
  }
  return;
}

//Handles user selecting side button--again, the ton of variables it might update
void HandleSideButton(int x, int y, int current_top_button,
  int *current_side_button, int *shape_current, int shape[], int shape_animate[],
  int shape_flash[], int shape_x[], int shape_y[], int shape_color1[], 
  int shape_color2[], int shape_size[], int *message_current, int message[], 
  int message_scroll[], int message_x [], int message_y[], int message_color[], 
  int message_size[], int message_speed[], int border[], int border_color1[], 
  int border_color2[], int border_size[], int *status, int *background_color) {

  int animate, flash, old_side_button = *current_side_button, scroll, count, 
      mess, check=0;
  FILE *file_var;
  
  *current_side_button = 
    (int)fabs ((GP142_YMAX - (int)(BUTTON_HEIGHT * 1.5) - y) / BUTTON_HEIGHT);  

  if (current_top_button == TOP_FILE) {
    //File button selected
    *status = STATUS_FILE;    
    if (*current_side_button < 3) {
      //Save routines
      switch (*current_side_button) {
        //Find the file to save to
        case 0: file_var = fopen("c:dave1.sav", "w"); break;
        case 1: file_var = fopen("c:dave2.sav", "w"); break;
        case 2: file_var = fopen("c:dave3.sav", "w"); break;
      }
      //Print the arrays to the file
      fprintf (file_var, "%i", *background_color);      
      fprintf (file_var, "%c", ' ');   
      fprintf (file_var, "%i", border[0]);
      fprintf (file_var, "%c", ' ');   
      fprintf (file_var, "%i", border_color1[0]);
      fprintf (file_var, "%c", ' ');   
      fprintf (file_var, "%i", border_color2[0]);
      fprintf (file_var, "%c", ' ');   
      fprintf (file_var, "%i", border_size[0]);
      fprintf (file_var, "%c", '\n');   
      for (count = 0; count < NUM_SHAPES; count++) {
        fprintf (file_var, "%i", shape [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_x [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_y [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_color1 [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_color2 [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_animate [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_flash [count]);
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", shape_size [count]);
        fprintf (file_var, "%c", '\n');   
      }
        
      for (count = 0; count < NUM_MESSAGES; count++) {
        fprintf (file_var, "%i", message [count]);        
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", message_x [count]);        
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", message_y [count]);        
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", message_color [count]);        
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", message_scroll [count]);        
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", message_speed [count]);        
        fprintf (file_var, "%c", ' ');   
        fprintf (file_var, "%i", message_size [count]);        
        fprintf (file_var, "%c", '\n');           
      }
      fclose (file_var);//Close out the file
    } else {
      //Load a file
      switch (*current_side_button) {
        //find the appropriate file
        case 3:
          if ( (file_var = fopen ("c:dave1.sav", "r")) == NULL) check = 1;
          break;
        case 4:
          if ( (file_var = fopen ("c:dave2.sav", "r")) == NULL) check = 1;
          break;
        case 5:
          if ( (file_var = fopen ("c:dave3.sav", "r")) == NULL) check = 1;
          break;
      }
      if (check != 1) {
        //Make sure the file exists, then load it into memory
        *shape_current = -1;
        *message_current = -1;
        fscanf (file_var, "%i", background_color);      
        fscanf (file_var, "%i", &border[0]);
        fscanf (file_var, "%i", &border_color1[0]);
        fscanf (file_var, "%i", &border_color2[0]);
        fscanf (file_var, "%i", &border_size[0]);
        for (count = 0; count < NUM_SHAPES; count++) {
          fscanf (file_var, "%i", &shape [count]);
          fscanf (file_var, "%i", &shape_x [count]);
          fscanf (file_var, "%i", &shape_y [count]);
          fscanf (file_var, "%i", &shape_color1 [count]);
          fscanf (file_var, "%i", &shape_color2 [count]);
          fscanf (file_var, "%i", &shape_animate [count]);
          fscanf (file_var, "%i", &shape_flash [count]);
          fscanf (file_var, "%i", &shape_size [count]);
        }
        for (count = 0; count < NUM_MESSAGES; count++) {
          fscanf (file_var, "%i", &message [count]);        
          fscanf (file_var, "%i", &message_x [count]);        
          fscanf (file_var, "%i", &message_y [count]);        
          fscanf (file_var, "%i", &message_color [count]);        
          fscanf (file_var, "%i", &message_scroll [count]);        
          fscanf (file_var, "%i", &message_speed [count]);        
          fscanf (file_var, "%i", &message_size [count]);        
        }
        fclose (file_var);
      }
    }
    //This selected the button for a moment
    DrawSideButtons (current_top_button, *current_side_button);
    pause();
    *current_side_button = -1;
  } else if (current_top_button == TOP_SHAPE ) {
    //Handle shape cases
    if ( (*current_side_button != SHAPE_ADD && 
          *current_side_button != SHAPE_SELECT) &&
          *shape_current ==	-1) {
      //No shape selected, so all but top two buttons are invalid
      DrawSideButtons (current_top_button, *current_side_button);
      DrawStatus (STATUS_NO_SHAPE_SELECTED, current_top_button);      
      pause();
      *current_side_button = 0;
      *status = STATUS_ADD_SHAPE;
    } else {
     //Handle Animation and Flash changes, then go on and update buttons
     if (*current_side_button == SHAPE_ANIMATE) {
        //Animation button selected, changed animation value
        animate = shape_animate [*shape_current];
        if (animate == 0) 
          animate = 1;
        else
          animate = 0;
        shape_animate[*shape_current] = animate;
        DrawSideButtons (current_top_button, *current_side_button);
        DrawStatus (STATUS_SHAPE_ANIMATION, current_top_button);
        pause();
        *current_side_button = old_side_button;
      }      
      if (*current_side_button == SHAPE_FLASH) {
        //Flash button selected, change flash value
        flash = shape_flash [*shape_current];
        if (flash == 0) 
          flash = 1;
        else
          flash = 0;
        shape_flash[*shape_current] = flash;
        DrawSideButtons (current_top_button, *current_side_button);
        DrawStatus (STATUS_SHAPE_FLASH, current_top_button);
        pause();
        *current_side_button = old_side_button;
      }    
      if (*current_side_button == SHAPE_REMOVE) {
        //Remove button selected, get rid of the shape
        shape[*shape_current] = -1;
        *shape_current = -1;
        DrawSideButtons (current_top_button, *current_side_button);
        pause();
        *current_side_button = SHAPE_ADD;
      }

      if (*current_side_button == SHAPE_ADD) {
        //Change status for adding a shape
        *status = STATUS_ADD_SHAPE;
      } else if (*current_side_button == SHAPE_SELECT) {
        //Change status for selecting a shape
        *status = STATUS_SELECT_SHAPE;
      }
    }
  } else if (current_top_button == TOP_MESSAGE) {
    //Handle Message buttons
    if ( (*current_side_button != MESSAGE_ADD && 
          *current_side_button != MESSAGE_SELECT) &&
          *message_current ==	-1) {
      //No shape selected, so all but top two buttons are invalid
      DrawSideButtons (current_top_button, *current_side_button);
      DrawStatus (STATUS_NO_MESSAGE_SELECTED, current_top_button);
      pause();
      *current_side_button = 0;
      *status = STATUS_ADD_MESSAGE;
    } else {
      //Scroll button is special
      if (*current_side_button == MESSAGE_SCROLL) {
        scroll = message_scroll [*message_current];
        if (scroll == 1) 
          scroll = 0;
        else
          scroll = 1;
        message_scroll[*message_current] = scroll;
        DrawSideButtons (current_top_button, *current_side_button);
        DrawStatus (STATUS_MESSAGE_SCROLL, current_top_button);
        pause();
        *current_side_button = old_side_button;
      }    
      if (*current_side_button == MESSAGE_REMOVE) {
        
        if (old_side_button == MESSAGE_SELECT) {
          //If last button was "select", then user wants to remove subliminals
          for (count = 0; count < NUM_MESSAGES; count++) {
            mess = message [count];
            if (mess == 6)
              message[count] = -1;
          }
          DrawSideButtons (current_top_button, *current_side_button);
          pause();
          *current_side_button = MESSAGE_SELECT;
          *message_current = -1;
        } else {
          //Other wise, remove the current message
          message[*message_current] = -1;
          *message_current = -1;
          pause();
          *current_side_button = MESSAGE_ADD;
        }
      }

      if (*current_side_button == MESSAGE_ADD) {
        //Set status for adding a message
        *status = STATUS_ADD_MESSAGE;
      } else if (*current_side_button == MESSAGE_SELECT) {
        //Set status for selecting a message
        *status = STATUS_SELECT_MESSAGE;
      }
    }
  } else if (current_top_button == TOP_BORDER) {
    //Border buttons
    if (*current_side_button != BORDER && border[0] == -1) {
      //Handles situation if there is no border currently selected
      DrawSideButtons (current_top_button, *current_side_button);
      DrawStatus (STATUS_NO_BORDER_SELECTED, current_top_button);
      pause();
      *current_side_button = 0;
      *status = STATUS_BORDER;
    }      
  } 
  return;
}

/*This function figures out where on the screen the user selected.  Pass it the 
coordinates of the click, the current top button, and the current status of the program,
and it will return a click_#define.*/
int ClassifyMouseClick(int mouse_x, int mouse_y, int current_top_button, 
                       int *status) {
  int side_buttons;
  switch (current_top_button) {
    //Determines the number of buttons on the side
    case TOP_BACKGROUND: side_buttons = BACKGROUND_BUTTONS; break;
    case TOP_BORDER:     side_buttons = BORDER_BUTTONS;     break;
    case TOP_SHAPE:      side_buttons = SHAPE_BUTTONS;      break;
    case TOP_MESSAGE:    side_buttons = MESSAGE_BUTTONS;    break;
    case TOP_FILE:       side_buttons = FILE_BUTTONS;       break;
  }
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX - (int)(BUTTON_HEIGHT * 1.5)) &&
      (mouse_y > GP142_YMAX - (int)(BUTTON_HEIGHT * (side_buttons + 1.5)) )
     )
    //User clicked on a side button
    return CLICK_SIDE_BUTTON;
  else if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH*TOP_BUTTONS) &&      
           (mouse_y > (GP142_YMAX - BUTTON_HEIGHT)))
    //User clicked on a top button
    return CLICK_TOP_BUTTON;
  else if (mouse_x >= PAGE_LLX && mouse_x < PAGE_LLX + PAGE_WIDTH
	  && mouse_y >= PAGE_LLY && mouse_y < PAGE_LLY + PAGE_HEIGHT)
    //User clicked on card
    return CLICK_CARD;
  else if ((*status == STATUS_COLOR_PALLETE) && 
           (mouse_x <= (-GP142_XMAX + BUTTON_WIDTH * 1.25)) &&
           (mouse_y <= (-GP142_YMAX + BUTTON_WIDTH))
          )
    //On color pallete
    return CLICK_COLOR_PALLETE;
  else if ((*status == STATUS_SHAPE_PALLETE) && 
           (mouse_x <= (-GP142_XMAX + BUTTON_WIDTH * 1.25)) &&
           (mouse_y <= (-GP142_YMAX + BUTTON_WIDTH))
          )
    //On shape pallete
    return CLICK_SHAPE_PALLETE;
  else if ((*status == STATUS_SIZE_PALLETE) &&
           (mouse_x <= (-GP142_XMAX + BUTTON_WIDTH * 1.25)) &&
           (mouse_y <= (-GP142_YMAX + BUTTON_WIDTH))
          )
    //On size pallete
    return CLICK_SIZE_PALLETE;
  else if ((*status == STATUS_SPEED_PALLETE) &&
           (mouse_x <= (-GP142_XMAX + BUTTON_WIDTH * 1.25)) &&
           (mouse_y <= (-GP142_YMAX + BUTTON_WIDTH))
          )
    //On speed pallete
    return CLICK_SPEED_PALLETE;
  else if ((*status == STATUS_MESSAGE_PALLETE) &&
           (mouse_x <= (-GP142_XMAX + BUTTON_WIDTH * 1.25)) &&
           (mouse_y <= (-GP142_YMAX + BUTTON_WIDTH * 1.25))
          )
    //On message pallete
    return CLICK_MESSAGE_PALLETE;
  else if ((*status == STATUS_BORDER_PALLETE) && 
           (mouse_x <= (-GP142_XMAX + BUTTON_WIDTH * 1.25)) &&
           (mouse_y <= (-GP142_YMAX + BUTTON_WIDTH * 1.25))
          )
    //On border pallete
    return CLICK_BORDER_PALLETE;
  else 
    //User didn't click anywhere of interest
    return CLICK_OUTSIDE;

}	

/*Draws a pallete of available sizes.  Pass the size to highlight.
All palletes follow same basic idea.*/
void DrawSizePallete (int size) {
  int x1, x2, y1, y2, y_width, count, y, color;
  char button_labels [4][25] = {"Small", "Medium", "Large", "Huge"};

  //Get pallete points
  x1 = -GP142_XMAX;
  y1 = -GP142_YMAX;
  x2 = x1 + (int)(BUTTON_WIDTH * 1.25);
  y2 = y1 + BUTTON_WIDTH;

  y_width = BUTTON_WIDTH / 4;

  //Loops to draw options
  for (count = 0; count < 4; count++) {
    y = y1 + y_width * count;   
    GP142_lineXY (BLACK, x1, y, x2, y, 1);
    if (count == size)
      color = RED;
    else
      color = BLACK;
    GP142_printfXY (color, x1 + (y_width / 2), y + (y_width / 6), 
                    ((y_width * 2) / 3), button_labels[count]);
  }
  GP142_rectangleXY (BLACK, x1, y1, x2, y2, NOFILL);
}

/*Draws a pallete of available messages.  Pass the message to highlight.*/
void DrawMessagePallete (int message) {
  int x1, x2, y1, y2, y_width, count, y, color;  
  char button_labels [7][25] = {
    "I love you", 
    "Will you be mine?", 
    "Kiss me",
    "For my sweetie",
    "From your honey",
    "GO DAWGS!",
    "Subliminal"
  };

  x1 = -GP142_XMAX;
  y1 = -GP142_YMAX;
  x2 = x1 + (int)(BUTTON_WIDTH * 1.25);
  y2 = y1 + (int)(BUTTON_WIDTH * 1.25);

  y_width = (int)(BUTTON_WIDTH * 1.25) / 7;

  for (count = 0; count < 7; count++) {
    y = y1 + y_width * count;   
    GP142_lineXY (BLACK, x1, y, x2, y, 1);
    if (count == message)
      color = RED;
    else
      color = BLACK;
    GP142_printfXY (color, x1 + (y_width / 2), y + (y_width / 6), 
                    ((y_width * 2) / 3), button_labels[count]);
  }
  GP142_rectangleXY (BLACK, x1, y1, x2, y2, NOFILL);
}

/*Draws a pallete of available speeds.  Pass the speed to highlight.*/
void DrawSpeedPallete (int speed) {
  int x1, x2, y1, y2, y_width, count, y, color;  
  char button_labels [5][25] = {
    "Slowest", 
    "Slow", 
    "Medium",
    "Fast",
    "Fastest"
  };

  x1 = -GP142_XMAX;
  y1 = -GP142_YMAX;
  x2 = x1 + (int)(BUTTON_WIDTH * 1.25);
  y2 = y1 + BUTTON_WIDTH;

  y_width = BUTTON_WIDTH / 5;

  for (count = 0; count < 5; count++) {
    y = y1 + y_width * count;   
    GP142_lineXY (BLACK, x1, y, x2, y, 1);
    if (count == speed)
      color = RED;
    else
      color = BLACK;
    GP142_printfXY (color, x1 + (y_width / 2), y + (y_width / 6), 
                    ((y_width * 2) / 3), button_labels[count]);
  }
  GP142_rectangleXY (BLACK, x1, y1, x2, y2, NOFILL);
}

/*Draws a borders of available speeds.  Pass the border to highlight.*/
void DrawBorderPallete (int border[]) {
  int x[4], y[4],       
      size[4] = {30, 30, 30, 30},       
      color1[4] = {BLACK, BLACK, BLACK, BLACK,}, 
      color2 [4] = {WHITE, WHITE, WHITE, WHITE,};
  int x1, x2, y1, y2, x_width, y_width, font_height, y3, color_text;
  
  x1 = -GP142_XMAX;
  y1 = -GP142_YMAX;
  x2 = x1 + (int)(BUTTON_WIDTH * 1.25);
  y2 = y1 + (int)(BUTTON_WIDTH * 1.25);
  y3 = y2 - (int)(BUTTON_WIDTH * 0.25);
  
  x_width = (int)((BUTTON_WIDTH * 1.25) / 2);
  y_width = BUTTON_WIDTH / 2;
  font_height = (int)(BUTTON_WIDTH * 0.16666);//(2/3) * (1/4)

  x[0] = x1 + (x_width / 2);
  y[0] = y1 + (y_width / 2);
  x[1] = x[0] + x_width;
  y[1] = y[0];
  x[2] = x[0];
  y[2] = y[0] + y_width;
  x[3] = x[1];
  y[3] = y[2];

  if (border [0] != -1) {
    color1[border[0]] = RED;
    color2[border[0]] = YELLOW;
    color_text = BLACK;
  } else {
    color_text = RED;
  }

  DrawBorderShape (x[0], y[0], color1[0], color2[0], size[0], size[0], 0);
  DrawBorderShape (x[1], y[1], color1[1], color2[1], size[1], size[1], 1);
  DrawBorderShape (x[2], y[2], color1[2], color2[2], size[2], size[2], 2);
  DrawBorderShape (x[3], y[3], color1[3], color2[3], size[3], size[3], 3);

  GP142_lineXY (BLACK, x1, y3, x2, y3, 1);
  GP142_printfXY (color_text, x1 + font_height, y3 + (font_height / 4), 
    font_height, "No border");
  GP142_rectangleXY (BLACK, x1, y1, x2, y2, NOFILL);
}

/*Draw a border shape.  Pass it all the good border info from the border array, but as ints,
rather than arrays*/
void DrawBorderShape (int x, int y, int color1, int color2, 
                      int size_x, int size_y, int shape) {
  int x1, x2, y1, y2;

  x1 = x - (size_x / 2);
  x2 = x + (size_x / 2);
  y1 = y - (size_y / 2);
  y2 = y + (size_y / 2);

  switch (shape) {
    case 0:
      //Solid border
      GP142_rectangleXY(color1, x1, y1, x2, y2, FILL);
      break;
    case 1:
      //Striped border
      GP142_triangleXY(color1, x1, y1, x1, y2, x2, y2, FILL);
      GP142_triangleXY(color2, x1, y1, x2, y1, x2, y2, FILL);
      break;
    case 2:
      //X border
      GP142_triangleXY(color1, x1, y1, x1, y2, x, y, FILL);
      GP142_triangleXY(color2, x1, y2, x2, y2, x, y, FILL);
      GP142_triangleXY(color1, x2, y2, x2, y1, x, y, FILL);
      GP142_triangleXY(color2, x2, y1, x1, y1, x, y, FILL);
      break;
    case 3:
      //Lined border
      GP142_rectangleXY(color1, x1, y1, x, y2, FILL);
      GP142_rectangleXY(color2, x2, y2, x, y1, FILL);
      break;
  }
}

/*Draw the shape pallete.  Pass is the shape to highlight*/
void DrawShapePallete (int shape) {
  /*I'm tired of using for loops.  This is going to be done the inefficient way
  using x and y variables for each of the four shapes*/

  int x[4], y[4],       
      animate[4] = {0, 0, 0, 0}, 
      size[4] = {SHAPE_SIZE_PALLETE, 
                 SHAPE_SIZE_PALLETE, 
                 SHAPE_SIZE_PALLETE, 
                 SHAPE_SIZE_PALLETE,}, 
      flash[4] = {0, 0, 0, 0}, 
      color1[4] = {BLACK, BLACK, BLACK, WHITE,}, 
      color2 [4] = {WHITE, WHITE, WHITE, BLACK,};
  int x1, x2, y1, y2, x_width, y_width;

  //Get coordinates
  x1 = -GP142_XMAX;
  y1 = -GP142_YMAX;
  x2 = x1 + (int)(BUTTON_WIDTH * 1.25);
  y2 = y1 + BUTTON_WIDTH;

  x_width = (int)(BUTTON_WIDTH * 1.25) / 2;
  y_width = BUTTON_WIDTH / 2;

  x[0] = x1 + (x_width / 2);
  y[0] = y1 + (y_width / 2);
  x[1] = x[0] + x_width;
  y[1] = y[0];
  x[2] = x[0];
  y[2] = y[0] + y_width;
  x[3] = x[1];
  y[3] = y[2];

  color1[shape] = RED;
  color2[shape] = WHITE;
  
  //Draw the shapes
  DrawHeart (x, y, color1, color2, size, animate, flash, 0);
  DrawStar  (x, y, color1, color2, size, animate, flash, 1);
  DrawSwirl (x, y, color1, color2, size, animate, flash, 2);
  DrawFace  (x, y, color2, color1, size, animate, flash, 3);

  GP142_rectangleXY (BLACK, x1, y1, x2, y2, NOFILL);
}

/*There are 24 colors, so they will be drawn in a 4 x 6 matrix.  Pass it the
number of the current color and it will highlight that color.*/
void DrawColorPallete (int color_num) {
  int x1, y1, x2, y2, x, y, count1, count2, color, x_width, color_count,
  y_width, border_color, border_x, border_y, rows, columns,
  color_list [24] = {//Make the colors look pretty on the pallete
    BLACK,    DUSTY_PLUM, NAVY_BLUE, FOREST_GREEN, BROWN, RED,            
    MED_GRAY, PURPLE,     BLUE,      SEA_GREEN,    OLIVE, ORANGE,     
    LT_GRAY,  MAGENTA,    CYAN,      GREEN,        GOLD,  YELLOW,
    WHITE,    PINK,       ICE_BLUE,  TURQUOISE,    PEACH, CHALK};

  color_count = 0;
  rows = 4;
  columns = 6;

  //Get coordinates for pallete
  x1 = -GP142_XMAX;
  y1 = -GP142_YMAX;
  x2 = x1 + (int)(BUTTON_WIDTH * 1.25);
  y2 = y1 + BUTTON_WIDTH;

  x_width = (int)(BUTTON_WIDTH * 1.25) / rows;
  y_width = BUTTON_WIDTH / columns;

  //Draw the colors  
  for (count1 = 0; count1 < rows; count1++) {
    x = x1 + (x_width * count1);
    for (count2 = 0; count2 < columns; count2++) {
      y = y1 + (y_width * count2);
      color = color_list[color_count];
      GP142_rectangleXY (color, x, y, x + x_width, y + y_width, FILL);
      if (color_num == color) {
        border_x = x;
        border_y = y;
      }
      color_count = color_count + 1;
    }   
  }

  //Highlight selected color (white gets a black highlight)
  if (color_num == WHITE)
    border_color = BLACK;
  else
    border_color = WHITE;

  //Draw the highlight
  GP142_rectangleXY (border_color, border_x,     border_y,     border_x + x_width,     border_y + y_width,     NOFILL);
  GP142_rectangleXY (border_color, border_x + 1, border_y - 1, border_x + x_width - 1, border_y + y_width + 1, NOFILL);
  GP142_rectangleXY (border_color, border_x - 1, border_y + 1, border_x + x_width + 1, border_y + y_width - 1, NOFILL);

  //Draw the edges
  GP142_rectangleXY (BLACK, x1, y1, x2, y2, NOFILL);
  return;
}

/*Handle palletes here if user selected one.  Pass the coordinates and ussually the current
item and an array, and it will change the color, shape, or whatever for you.  They all work
the same, and so they only get one collective comment here.*/
void HandleColorPallete (int mouse_x, int mouse_y, int current_top_button, 
  int current_side_button, int shape_current, int shape_color1[], 
  int shape_color2[], int message_current, int message_color[], int border[], 
  int border_color1[], int border_color2[], int *background_color) {
  
  int x, y, color,
  color_list [24] = {
    BLACK,    DUSTY_PLUM, NAVY_BLUE, FOREST_GREEN, BROWN, RED,            
    MED_GRAY, PURPLE,     BLUE,      SEA_GREEN,    OLIVE, ORANGE,     
    LT_GRAY,  MAGENTA,    CYAN,      GREEN,        GOLD,  YELLOW,
    WHITE,    PINK,       ICE_BLUE,  TURQUOISE,    PEACH, CHALK};

  x = (int)(mouse_x + GP142_XMAX) / (int)(BUTTON_WIDTH * 1.25 / 4);
  y = (int)(mouse_y + GP142_YMAX) / (int)(BUTTON_WIDTH / 6);
  color = color_list [x * 6 + y];
  if (current_top_button == TOP_SHAPE) {
    //Handle shape colors
    if (current_side_button == SHAPE_COLOR1) 
      shape_color1 [shape_current] = color;
    if (current_side_button == SHAPE_COLOR2) 
      shape_color2 [shape_current] = color;
  } else if (current_top_button == TOP_BACKGROUND) {
    //Handle Background color
    *background_color = color;
  } else if (current_top_button == TOP_MESSAGE) {
    //Message Colors
    message_color [message_current] = color;
  } else if (current_top_button == TOP_BORDER) {
    if (current_side_button == BORDER_COLOR1) 
      border_color1 [0] = color;
    if (current_side_button == BORDER_COLOR2) 
      border_color2 [0] = color;
  }
}
void HandleShapePallete (int mouse_x, int mouse_y, int shape_current, int shape[]) {
  int x, y;

  x = (int)(mouse_x + GP142_XMAX) / (int)(BUTTON_WIDTH * 1.25 / 2);
  y = (int)(mouse_y + GP142_YMAX) / (int)(BUTTON_WIDTH / 2);
  shape [shape_current] = x + y*2;
}
void HandleBorderPallete (int mouse_x, int mouse_y, int border[]) {
  int x, y;

  x = (int)(mouse_x + GP142_XMAX) / (int)(BUTTON_WIDTH * 1.25 / 2);
  y = (int)(mouse_y + GP142_YMAX) / (int)(BUTTON_WIDTH / 2);
  if (y > 1)
    border[0] = -1;
  else
    border[0] = x + y*2;
}
void HandleSizePallete (int mouse_x, int mouse_y, int current, int size[]) {
  int y;
  
  y = (int)(mouse_y + GP142_YMAX) / (int)(BUTTON_WIDTH / 4);
  size [current] = y;
}
void HandleMessagePallete (int mouse_x, int mouse_y, int current, int message[]) {
  int y;
  
  y = (int)(mouse_y + GP142_YMAX) / (int)(BUTTON_WIDTH * 1.25 / 7);
  message [current] = y;
}
void HandleSpeedPallete (int mouse_x, int mouse_y, int current, int speed[]) {
  int y;
  
  y = (int)(mouse_y + GP142_YMAX) / (int)(BUTTON_WIDTH / 5);
  speed [current] = y;
}


/*Draw the status based upon the status and current top button.*/
void DrawStatus (int status, int current_top_button) {
  char message [256];
  int font_size, color;  
  GP142_rectangleXY (LT_GRAY, 
                     PAGE_LLX, PAGE_LLY-40, 
                     GP142_XMAX, PAGE_LLY-40+STATUS_FONT_SIZE+2, 
                     FILL);

	switch (status) {
    //Huge switch to check status and set the message to print
  	case STATUS_ADD_SHAPE:
		  strcpy (message, "Click on the card to add a shape.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;
  	case STATUS_COLOR_PALLETE:
      switch (current_top_button) {
        case TOP_BACKGROUND:
        case TOP_BORDER:
		      strcpy (message, "Select a color from the pallete.");
          break;
        case TOP_SHAPE:
		      strcpy (message, 
            "Select a color from the pallete.\nShape can be moved by clicking on the card.");
          break;
        case TOP_MESSAGE:
		      strcpy (message, 
            "Select a color from the pallete.\nMessage can be moved by clicking on the card.");
          break;
      }
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;	  
    case STATUS_NO_SHAPE_SELECTED:
      strcpy (message, "No shape selected.");
      font_size = STATUS_FONT_SIZE;      
      color = RED;
		  break;
    case STATUS_MAX_SHAPES:
      strcpy (message, "Maximum number of shapes already inserted.");
      font_size = STATUS_FONT_SIZE;      
      color = RED;		  
  		break;
   case STATUS_SELECT_SHAPE:
      strcpy (message, 
        "Click on a shape to select it.\nStacked shapes may need to be moved to get to shapes underneath");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_NONE:
      strcpy (message, "");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_SHAPE_SELECTED:
      strcpy (message, "Shape selected.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_SHAPE_ANIMATION:
      strcpy (message, "Shape animation changed.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_SHAPE_FLASH:
      strcpy (message, "Shape flash changed.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
  	case STATUS_SHAPE_PALLETE:
		  strcpy (message, 
        "Select a shape from the pallete.\nShape can be moved by clicking on the card.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;
  	case STATUS_SIZE_PALLETE:
      switch (current_top_button) {     
        case TOP_BORDER:
		      strcpy (message, "Select a size from the list.");
          break;
        case TOP_SHAPE:
		      strcpy (message, 
            "Select a size from the list.\nShape can be moved by clicking on the card.");
          break;
        case TOP_MESSAGE:
		      strcpy (message, 
            "Select a size from the list.\nMessage can be moved by clicking on the card.");
          break;
      }
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;
  	case STATUS_ADD_MESSAGE:
		  strcpy (message, "Click on the card to add a message.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;
    case STATUS_MESSAGE_SELECTED:
      strcpy (message, "Message selected.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_MESSAGE_SCROLL:
      strcpy (message, "Message scroll changed.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_NO_MESSAGE_SELECTED:
      strcpy (message, "No message selected.");
      font_size = STATUS_FONT_SIZE;      
      color = RED;
		  break;      
  	case STATUS_MESSAGE_PALLETE:
		  strcpy (message, 
        "Select a message from the list.\nMessage can be moved by clicking on the card.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;
   case STATUS_MAX_MESSAGES:
      strcpy (message, "Maximum number of messages already inserted.");
      font_size = STATUS_FONT_SIZE;      
      color = RED;		  
  		break;
   case STATUS_SELECT_MESSAGE:
      strcpy (message, 
        "Click on a message to select it.\nPushing remove will remove any subliminal messages from the card.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_NO_BORDER_SELECTED:
      strcpy (message, "There is no border.");
      font_size = STATUS_FONT_SIZE;      
      color = RED;
		  break;     
  	case STATUS_SPEED_PALLETE:
		  strcpy (message, 
        "Select a speed from the list.\nMessage can be moved by clicking on the card.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;		  
      break;
    case STATUS_BORDER:
      strcpy (message, "Select a border from the list.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
    case STATUS_BORDER_PALLETE:
      strcpy (message, "Select a border from the list.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
     case STATUS_FILE:
      strcpy (message, "Files are saved as C:DAVE1-3.SAV.");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
		  break;     
          
  	default:
      strcpy (message, "Status error -- notify programmer");
      font_size = STATUS_FONT_SIZE;      
      color = BLACK;
  		break;
	}
 	GP142_printfXY (color, PAGE_LLX, PAGE_LLY-40, font_size, message);
}

/*Draw the border based upon the passed border values (not border arrays)*/
void DrawBorder (int border, int color1, int color2, int size) {
  int left_x, right_x, lower_y, upper_y, size_x, size_y, x, y, count,
      temp;

  switch (size) {
    case 0://Small
      size = 40;
      break;
    case 2://large
      size = 10;
      break;
    case 3://Huge
      size = 8;
      break;
    case 1:
    default://Medium
      size = 20;
      break;
  }

  //Get starting coordinates
  size_x = PAGE_WIDTH / size;
  size_y = PAGE_HEIGHT / size;

  left_x  = PAGE_LLX + (size_x / 2);
  right_x = left_x + PAGE_WIDTH - size_x;
  lower_y = PAGE_LLY + (size_y / 2);
  upper_y = lower_y + PAGE_HEIGHT - size_y;
  x = 0;
  y = 0;

  /*In each of the loops, either the top AND bottom, or left AND right are
  drawn at the same time with opposite colors*/

  //Loop through top and bottom edges
  for (count = 0; x < right_x; count++) {
    x = left_x + size_x * count;
    DrawBorderShape (x, lower_y, color1, color2, size_x, size_y, border);
    //Flip colors to get nice looking effects
    temp = color1;
    color1 = color2;
    color2 = temp;
    DrawBorderShape (x, upper_y, color1, color2, size_x, size_y, border);
  }    

  //Flip colors again to get everything looking right
  temp = color1;
  color1 = color2;
  color2 = temp;

  //Do left and right sides
  for (count = 1; y < PAGE_LLY + PAGE_HEIGHT - size_y; count++) {
    y = lower_y + size_y * count;
    DrawBorderShape (left_x,  y, color1, color2, size_x, size_y, border);
    //Again, flip colors
    temp = color1;
    color1 = color2;
    color2 = temp;
    DrawBorderShape (right_x, y, color1, color2, size_x, size_y, border);
  }
}

/*Deal with user clicking on the card.  Pass a bunch of variables, and it will figure out
what to add, move, or select.*/
void HandleCardClick (int mouse_x, int mouse_y, int current_top_button, 
  int *current_side_button, int *status, int *shape_current, int shape[], 
  int shape_x[], int shape_y[], int *message_current, int message[], 
  int message_x[], int message_y[]) {

  int shape_num, new_shape, message_num, new_message;  
  if (current_top_button == TOP_SHAPE) {
    //Handle Shape Stuff
    if (*current_side_button == SHAPE_ADD) {
      //If the user wants to add a shape
      shape_num = find_open_slot (shape, NUM_SHAPES);    
      if (shape_num == -1) {
        //Too many shapes already
        *status = STATUS_MAX_SHAPES;
      } else {
        //Add a shape
        shape[shape_num] = SHAPE_HEART;      
        shape_x [shape_num] = mouse_x;
        shape_y [shape_num] = mouse_y;
        *current_side_button = SHAPE_SHAPE;
        *shape_current = shape_num;
        *status = STATUS_NONE;
      }
    } else if (*current_side_button != SHAPE_SELECT &&
               *shape_current != -1) {
      //Move a shape
      shape_x [*shape_current] = mouse_x;
      shape_y [*shape_current] = mouse_y;
    } else if (*current_side_button == SHAPE_SELECT) {
      //Select a shape
      new_shape = check_xy (shape_x, shape_y, mouse_x, mouse_y, NUM_SHAPES);
      if (new_shape != -1) {      
        *current_side_button = SHAPE_SHAPE;
        *shape_current = new_shape;
        *status = STATUS_NONE;
        //Tag the shape so the user know one has been selected
        draw_tag (mouse_x, mouse_y);
        DrawStatus (STATUS_SHAPE_SELECTED, current_top_button);
      }
    }
  } else if (current_top_button == TOP_MESSAGE) {
    //Handle message Stuff
    if (*current_side_button == MESSAGE_ADD) {
      //If the user wants to add a message
      message_num = find_open_slot (message, NUM_MESSAGES);    
      if (message_num == -1) {
        //Too many messages already
        *status = STATUS_MAX_MESSAGES;
      } else {
        //Add a message
        message[message_num] = 0;      
        message_x [message_num] = mouse_x;
        message_y [message_num] = mouse_y;
        *current_side_button = MESSAGE_MESSAGE;
        *message_current = message_num;
        *status = STATUS_NONE;
      }
    } else if (*current_side_button != MESSAGE_SELECT &&
               *message_current != -1) {
      //Move a message
      message_x [*message_current] = mouse_x;
      message_y [*message_current] = mouse_y;
    } else if (*current_side_button == MESSAGE_SELECT) {
      //Select a message
      new_message = check_xy (message_x, message_y, mouse_x, mouse_y, 
                              NUM_MESSAGES);
      if (new_message != -1) {      
        *current_side_button = MESSAGE_MESSAGE;
        *message_current = new_message;
        *status = STATUS_NONE;
        //Tag the message so the user know one has been selected
        draw_tag (mouse_x, mouse_y);
        DrawStatus (STATUS_MESSAGE_SELECTED, current_top_button);
      }
    }
  }
}

/*Draws a tag when selecting an element so the user knows it was selected.  Pass the
x and y mouse variables*/
void draw_tag (mouse_x, mouse_y) {
  int dummy1, dummy2, count;
  char dummy3;
  GP142_lineXY(GREEN, mouse_x+8,  mouse_y+8,  mouse_x-8,  mouse_y-8,  2);
  GP142_lineXY(RED,   mouse_x+10, mouse_y,    mouse_x-10, mouse_y,    2);
  GP142_lineXY(GREEN, mouse_x-8,  mouse_y+8,  mouse_x+8,  mouse_y-8,  2);
  GP142_lineXY(RED,   mouse_x,    mouse_y+10, mouse_x,    mouse_y-10, 2);
  for (count = 0; count < 5; count++) {
    GP142_await_event(&dummy1, &dummy2, &dummy3);
  }

  return;
}

/*Checks the x and y variables to see if user selected anything.  Pass the
coordinate ints, the length of them, and the point to check.   Will return
-1 for nothing there, or the number of the element*/        
int check_xy (int x[], int y[], int x_check, int y_check, int length) {
  int count, x_num, y_num;
  
  for (count = 0; count < length; count++) {
    x_num = x[count];
    y_num = y[count];    
    //Fudge factor is set at 13 to allow for big pick box to get shapes
    if (x_num > (x_check - 13) &&
        x_num < (x_check + 13) &&
        y_num > (y_check - 13) &&
        y_num < (y_check + 13))
      return count;    
  }
  return -1;
}

/*Finds the next slot available for adding a message or array.  If one
was removed, then this will find that whole created by the user.
Pass the arry and the length, will return the next available slot.*/
int find_open_slot (int array[], int length) {
  int count, check, keep = -1;
  for (count = 0; count < length; count++) {
    check = array[count];
    if (check == -1) {
      keep = count;
      count = length;
    }
  }
  return (keep);
}

/*Utility function that just pauses for a moment, allowing buttons
to be pushed for just a moment*/
void pause() {
  int dummy1, dummy2, count;
  char dummy3;
  for (count = 0; count < 3; count++) {
    GP142_await_event(&dummy1, &dummy2, &dummy3);
  }
  return;
}
